module AbstractClass

  class NoImplementError < RuntimeError; end

  def self.included abstract
    abstract.instance_eval do
      def self.included base
        @abstract_methods.each do |ab|
          unless base.instance_methods.include? ab.to_s
            raise AbstractClass::NoImplementError
          end
        end
      end
    end
  end

end
